<script setup>
import { computed, defineAsyncComponent } from 'vue';
import Game from '../../game';
import InfoBlock from './info-block.vue';
import { CheckTypes } from './infoBlock.js';
//import Attack from './attack.vue';
//import Dot from './dot-info.vue';
import { precise } from '../../util/format';
import Summon from './summon.vue';
import { useDamage } from './use-damage';
import { formatNumber } from '../../util/format';
import { getHealing } from './healingMixin.js';

const Dot = defineAsyncComponent(() => import("./dot-info.vue"));
const Attack = defineAsyncComponent(() => import('./attack'));

const props = defineProps(['item']);
//	name:"gdata"

const { getDamage } = useDamage();

const player = Game.state.player;

/**
 * Convert tag strings into viewable format.
 * @param {string|string[]} t
 * @returns {string|string[]}
 */
function tagNames(t) {

	if (Array.isArray(t)) return t.map(tagNames);

	if (typeof t === 'string' && t.substring(0, 2) === 't_') return t.slice(2).toTitleCase();

	return t.toTitleCase();

}

function formatTime(millis) {
	if (millis < 0) millis = 0;
	const hr = Math.floor(millis / 3600000);
	const min = Math.floor(millis / 60000) % 60;
	const sec = Math.floor(millis / 1000) % 60;

	return `${(hr < 10 && "0") + hr}:${(min < 10 && "0") + min}:${(sec < 10 && "0") + sec}`;
}

const name = computed(() => { return props.item.sname || props.item.name.toTitleCase(); });
const damage = computed(() => {
	return getDamage(props.item);
});
const healing = computed(() => {
	return getHealing(props.item);
});
const sellPrice = computed(() => { return Game.sellPrice(props.item); });

const nextImprove = computed(() => {
	return nextAt.value > 0 ? nextAt.value : nextEvery.value;
});

/**
 * Occurance of next 'every' improvement relative to cur value.
 */
const nextEvery = computed(() => {

	let v = Math.floor(props.item.value);

	let next = Number.MAX_VALUE;

	let f;	// save every-divisor for pct computation.

	let dist = Number.MAX_VALUE;
	for (let p in props.item.every) {
		dist = p - (v % p);
		if (dist < next) {
			next = dist;
			f = p;
		}

	}

	return (next !== Number.MAX_VALUE) ? ((f - dist) / f) : -1;

});

const cdtags = computed(() => {
	if (!props.item.tags) return null;
	let tags = props.item.tags;
	if (typeof tags === 'string') tags = [tags];
	let names = [];
	for (let i = 0; i < tags.length; i++) {
		let tag = tags[i];
		tag = Game.state.tagSets[tag] || tag;
		if (tag == null || tag.hide || !tag.sharecd) continue;
		if (tag instanceof Object && tag.name) {
			names.push(tag.name.toTitleCase());
		} else {
			names.push(tagNames(tag));
		}
	}

	return names.join(', ');

});

const cdRemain = computed(() => {
	if (props.item.template) {
		let parentid = props.item.template;
		if (props.item.template.id) {
			parentid = props.item.template.id;
		}
		let parent = Game.state.getData(parentid);
		return parent.timer;
	} else {
		return props.item.timer;
	}
});

const nextAt = computed(() => {

	let v = props.item.value;

	// least upper bound.
	let sup = Number.MAX_VALUE;
	for (let p in props.item.at) {
		p = Number(p);
		if (p > v && p < sup) sup = p;
	}

	return (sup > v && sup !== Number.MAX_VALUE) ? sup : -1;

});

const tags = computed(() => {

	let tags = props.item.tags;
	if (typeof tags === 'string') tags = [tags];
	let names = [];
	for (var i = 0; i < tags.length; i++) {
		let tag = tags[i];
		tag = Game.state.tagSets[tag] || tag;
		if (tag == null || tag.hide) continue;
		if (tag instanceof Object && tag.name) {
			names.push(tag.name.toTitleCase());
		} else {
			names.push(tagNames(tag));
		}
	}

	return names.join(', ');

});
</script>


<template>
	<div class="item-info">
		<!-- Begin upper section of tooltip -->
		<span class="separate">
			<span class="item-name">{{ name.toString().toTitleCase() }}</span>

			<span v-if="item.type === 'resource' || item.type === 'stat'">
				{{ formatNumber(item.current.toFixed(0)) + (formatNumber(item.max) ? (' / ' + formatNumber(item.max.value))
					: '') }}
			</span>
			<span v-else-if="item.type === 'furniture'">
				max: {{ item.max ? formatNumber(item.max.value) : ((item.repeat) ? '&infin;' : 1) }}
			</span>
			<span v-else-if="item.type === 'upgrade' || item.type === 'task'">
				<br>
				<span v-if="item.value">{{ formatNumber(+item.value) }}</span>
				<span v-if="item.max">/ {{ formatNumber(+item.max) }}</span>
				<span v-else-if="item.type === 'upgrade'">/ 1</span>
			</span>

			<span v-if="item.type === 'locale' || item.type === 'dungeon'">
				<span v-if="item.value">{{ formatNumber(+item.value) }}</span>
				<span v-if="item.max">/ {{ formatNumber(+item.max) }}</span>
			</span>
			<span v-if="item.type === 'encounter'">
				<span v-if="item.value">{{ formatNumber(+item.value) }}</span>
			</span>

			<span v-if="item.sym">{{ item.sym }}</span>
		</span>

		<div class="tight note-text" v-if="item.tags || item.hands"><span v-if="item.hands > 1">Two-Handed </span>{{ tags }}
		</div>

		<span class="flex-right"
			v-if="item.rate && item.rate.value != 0 && !(item.type == 'task' || item.type == 'encounter' || item.type == 'explore' || item.type == 'dungeon' || item.type == 'locale' || item.type == 'spell')">{{
				precise(item.rate.value) }}/s</span>
		<span class="flex-right"
			v-if="item.rate && item.rate.value != 0 && item.length > 0 && (item.type == 'task' || item.type == 'encounter')">Completion
			rate: {{ precise(item.rate.value) * 100 }}%</span>
		<div>
			<span class="separate">
				<span v-if="item.showLevel">Level: {{ item.showLevel() }}</span>
				<span v-else-if="item.level">Level: {{ item.level }}</span>

				<span v-if="item.slot">Slot: {{ item.slot.toString().toTitleCase() }}</span>
			</span>

			<span v-if="item.enchants && item.enchants.max > 0">Enchant Levels: {{ item.enchants.value }} / {{
				item.enchants.max }}</span>

			<span v-if="item.at && (nextAt > 0)" class="note-text">
				Next Improvement: {{ Math.round(100 * item.value / nextAt) + '%' }}
			</span>
			<span v-else-if="item.every && (nextEvery >= 0)" class="note-text">
				Next Improvement: {{ Math.round(100 * nextEvery) + '%' }}
			</span>

			<div v-if="item.cd || cdRemain > 0" class="note-text">Cooldown: {{ cdRemain > 0 ? cdRemain.toFixed(2) + ' Left'
				: item.cd + 's' }}</div>
			<div v-if="cdtags" class="note-text">Shares cooldown with: {{ cdtags }}</div>
			<div v-if="+item.dist">Distance: {{ item.dist }}</div>
			<div v-if="+item.armor">Armor: {{ item.armor }}</div>
			<div v-if="+item.dmg && (!item.attack || item.attack.dmg !== item.dmg)">Base damage: {{ damage }}</div>
		<div v-if="+item.heal && (!item.attack || item.attack.heal !== item.heal)">Healing: {{ healing }}</div>

			<div class="item-desc" v-if="item.desc">{{ item.desc }}</div>
			<div class="item-extdesc" v-if="item.extdesc">{{ item.extdesc }}</div>
		</div>

		<span v-if="item.length > 0 && item.type === 'task'">
			Completion time: {{ formatTime((item.length - item.exp) * 1000 / (item.rate)) }}
		</span>
		<!-- End of upper section of tooltip -->

		<InfoBlock v-if="item.need" :info="item.need" :checkType="CheckTypes.NEED" title="Need" :require="true" />
		<InfoBlock v-if="item.buy && !item.owned" :info="item.buy" :checkType="CheckTypes.COST" title="Purchase Cost" />
		<InfoBlock v-if="item.cost" :info="item.cost" :checkType="CheckTypes.COST" title="Cost" />
		<InfoBlock v-if="item.sell || item.instanced || item.type === 'Furniture'" :info="sellPrice" :checkType="CheckTypes.FULL"
			title="Sell" />
		<InfoBlock v-if="item.run" :info="item.run" :checkType="CheckTypes.COST" title="Progress Cost" rate="true" />

		<div v-if="item.attack && item.type !== 'armor'">
			<div class="info-sect">Attack</div>
			<attack :item="item" class="info-subsubsect" />
		</div>
		<div v-if="item.onDeath && item.type !== 'armor'">
			<div class="info-sect">When killed</div>
			<attack :item="item" ondeathflag="true" class="info-subsubsect" />
		</div>
		<div v-if="item.onExpire && item.type !== 'armor'">
			<div class="info-sect">On expiration</div>
			<attack :item="item" onexpireflag="true" class="info-subsubsect" />
		</div>

		<div v-if="item.effect">
			<div class="info-sect">Effects:</div>
			<InfoBlock :info="item.effect" :rate="item.perpetual > 0 || item.length > 0" :checkType="CheckTypes.FULL" />
		</div>

		<div v-if="(item.mod && Object.values(item.mod).length) || (item.alter && Object.values(item.alter).length)">
			<div class="info-sect">Modifications:</div>
			<InfoBlock v-if="item.mod && Object.values(item.mod).length" :info="item.mod" />
			<InfoBlock v-if="item.alter && Object.values(item.alter).length" :info="item.alter" />
		</div>
		<div v-if="item.convert">
			<div class="info-sect">Conversion per {{ name.toString().toTitleCase() }}</div>
			<div class="info-sect">Input:</div>
			<InfoBlock :info="item.convert.input" :rate="item.perpetual > 0 || item.length > 0" :checkType="CheckTypes.COST" />
			<div class="info-sect">Output:</div>
			<InfoBlock v-if="item.convert.output.effect && Object.values(item.convert.output.effect).length"
				:info="item.convert.output.effect" :rate="item.perpetual > 0 || item.length > 0"
				:checkType="CheckTypes.FULL" />
			<InfoBlock v-if="item.convert.output.mod && Object.values(item.convert.output.mod).length"
				:info="item.convert.output.mod" />
		</div>
		<div v-if="item.summon">
			<div class="info-sect">Summons:</div>
			<summon :item="item" class="info-subsubsect" />
		</div>
		<div v-if="item.result">
			<div class="info-sect">Results:</div>
			<InfoBlock :info="item.result" :checkType="CheckTypes.FULL" />
		</div>

		<div v-if="item.use">
			<div class="info-sect">When used:</div>
			<div class="info-subsubsect">
				<InfoBlock :info="item.use" :separate="true" />
				<!-- <attack v-if="item.use.attack" :item="item.use" /> -->
			</div>
		</div>

		<div v-if="item.runmod && Object.values(item.runmod).length">
			<div class="info-sect">When active:</div>
			<InfoBlock :info="item.runmod" />
		</div>

		<div v-if="item.dot">
			<div class="info-sect">Buffs:</div>
			<dot :dot="item.dot" :item="item" class="info-subsubsect" />
		</div>

		<div v-if="item.lock">
			<div class="info-sect">Locks:</div>
			<InfoBlock :info="item.lock" />
		</div>

		<div v-if="item.disable">
			<div class="info-sect">Disables:</div>
			<InfoBlock :info="item.disable" />
		</div>

		<div v-if="item.enable">
			<div class="info-sect">Enables:</div>
			<InfoBlock :info="item.enable" />
		</div>

		<div class="note-text" v-if="item.flavor">{{ item.flavor }}</div>
	</div>
</template>


<style scoped>
.tight {
	margin: 0;
	padding: 0;
}

div.item-desc {
	margin: 0.6em 0 0.9em;
	font-size: 0.96em;
}

div.item-extdesc {
	margin: 0.6em 0 0.9em;
	font-size: 0.8em;
}

.item-name {
	font-weight: bold;
}

.separate>span {
	margin-left: var(--small-gap);
}

.flavor {
	font-style: italic;
}
</style>
